                                                          September 20, 1993
                                                          Fairfield, Iowa

                Broadcast Channel Wizard User's Manual

INSTALLATION:

The Broadcast Channel Wizard is distributed in a compressed file, WIZTOOLS.ZIP
Use PKWARE's PKUNZIP to extract the contents of this file as follows:

c:\WIZTOOLS>PKUNZIP -d WIZTOOLS.ZIP

NOTE: The "-d" option creates two subdirectories,  ".\BCWIZ" and
      ".\BCWIZ\EXAMPLE"


BROADCAST CHANNEL THEORY:

A Broadcast Channel is a producer/consumer model rather than a client/server
model.  Communications is one-way from producers to consumers.  Producers
and consumers are loosely coupled--neither must know of the other.  They only
know about the global Broadcaster object, variable oBroadcaster, and it's
broadcast channels.

Consumers connect to one or more broadcast channels by invoking the Connect 
method of the Broadcaster.  The Disconnect method reverses this action. 
Producers invoke the Broadcaster's "broadcast" methods to send data.  When 
invoked in this way the Broadcaster sends the data to each consumer object 
connected. 

See the supplied example program to get a better understanding of this concept.


BROADCAST CHANNEL WIZARD USE:

The Broadcast Channel Wizard comes bundled with two static source code files:

    1) CHANNEL.H
    2) CHANNEL.CPP  -- Implements a channel list used by BRDCASTR.CPP

The Broadcast Channel Wizard reads a channel specification file and generates
four files:

    1) CHNNLDEF.H   -- Declares each channel specified as a class.
    2) BRDCASTR.H   -- Declares class Broadcaster which includes methods
                       for broadcast channel.
    3) BRDCASTR.CPP -- Defines the class Broadcaster's methods.
    4) APP.CPP      -- Code templates available for a programmer to use
                       writing broadcast channel producers and consumers.

Usage: >BCWIZ <specification file name>

Each Broadcast Channel is specified as a C++ function prototype in the
channel specification file.  An entry in this file has the following format:

<broadcast channel function prototype> {max receivers};

where: "{max receivers}" is optional; it defaults to 10.  No more the
       "max receivers" can be connected to any one channel at a time.

IMPORTANT: The function prototype used to declare a broadcast channel
           must include argument type specifiers AND argument names.
           
There can be up to 200 entries in the specification file.

Build your project with output files BRDCASTR.CPP and static file CHANNEL.CPP
Include files CHNNLDEF.H and BRDCASTR.H when writing client/server modules.

EXAMPLE:

If you unzipped the distribution file with the "-d" option then an example
subdirectory ".\BCWIZ\EXAMPLE" was created.  Read file "README.TXT" in this
subdirectory for an explanation of the example.


SOURCE CODE:

If you unzipped the distribution file with the "-d" option then the Broadcast 
Channel Wizard's source code was stored in subdirectory ".\BCWIZ"   The 
Wizard's source code is supplied because you may want to modify this program 
to satisfy your personal coding style. Read file "BCWIZ.TXT" in subdirectory 
".\BCWIZ" for a description of the design of the Wizard program. 


SUPPORT:

For more information, contact:

Rob Buck
The Aerosoft Company
51 N. Cromwell
Fairfield, IA  52556
(515) 472-7586
CompuServe: 72260,3551

