#ifndef _brdcastr_h_
#define _brdcastr_h_

//  Module: BRDCASTR.H

#include "CHANNEL.H"
#include "CHNNLDEF.H"

class Broadcaster {
    Channel oWindDataChannel;
    Channel oAirDataChannel;
    Channel oTornadoWarningChannel;
public:
    int Connect (WindData *op);
    int Disconnect (WindData *op);
    int ChannelStatus (WindData *)
    {return oWindDataChannel.Status();}
    void BroadcastWindData (int iSpeed, int iDirection);
    int Connect (AirData *op);
    int Disconnect (AirData *op);
    int ChannelStatus (AirData *)
    {return oAirDataChannel.Status();}
    void BroadcastAirData (int iTemperature,
         int iBarometricPressure,
         int iHumdity);
    int Connect (TornadoWarning *op);
    int Disconnect (TornadoWarning *op);
    int ChannelStatus (TornadoWarning *)
    {return oTornadoWarningChannel.Status();}
    void BroadcastTornadoWarning (void);
};

    extern Broadcaster    oBroadcaster;

#endif
