                                                          September 20, 1993
                                                          Fairfield, Iowa

                Roster Wizard User's Manual

INSTALLATION:

The Roster Wizard is distributed in a compressed file, WIZTOOLS.ZIP
Use PKWARE's PKUNZIP to extract the contents of this file as follows:

c:\WIZTOOLS>PKUNZIP -d WIZTOOLS.ZIP

NOTE: The "-d" option creates two subdirectories,  ".\ROSWIZ" and
      ".\ROSWIZ\EXAMPLE"


ROSTER CHANNEL THEORY:

A Roster provides a list of servers available to clients.  Clients use
functions First and Next to scan through the list of servers calling
each one.

Servers use functions Connect and Disconnect make themselves available
to clients.

See the example to get a better understanding of this concept.


ROSTER WIZARD USE:

The Roster Wizard comes bundled with two static source code files:

    1) CHANNEL.H
    2) CHANNEL.CPP  -- Implements a channel list used by REGISTER.CPP

The Roster Wizard reads a channel specification file and generates
four files:

    1) CHNNLDEF.H   -- Declares each channel specified as a class.
    2) ROSTER.H     -- Declares class Roster which includes methods
                       for each roster channel.
    3) ROSTER.CPP   -- Defines the class Roster's methods.
    4) APP.CPP      -- Code templates available for a programmer to use
                       writing broadcast channel client and servers.


Usage: >ROSWIZ <specification file name>

Each Roster Channel is specified as a C++ function prototype in the
channel specification file.  An entry in this file has the following format:

<roster server function prototype> [default return value] {max receivers};

where: "[default return value]" is optional; it defaults to 0.
       "{max receivers}" is optional; it defaults to 10.  No more the
       "max receivers" can be connected to any one channel at a time.

IMPORTANT: The function prototype used to declare a server
           must include argument type specifiers AND argument names.
           
There can be up to 200 entries in the specification file.

Build your project with output files REGISTER.CPP and static file CHANNEL.CPP
Include files CHNNLDEF.H and REGISTER.H when writing client/server modules.

EXAMPLE:

If you unzipped the distribution file with the "-d" option then an example
subdirectory ".\ROSWIZ\EXAMPLE" was created.  Read file "README.TXT" in this
subdirectory for an explanation of the example.


SOURCE CODE:

If you unzipped the distribution file with the "-d" option then the Roster 
Wizard's source code was stored in subdirectory ".\ROSWIZ"   The Wizard's 
source code is supplied because you may want to modify this program to satisfy 
your personal coding style. Read file "ROSWIZ.TXT" in subdirectory ".\ROSWIZ" 
for a description of the design of the Wizard program. 


SUPPORT:

For more information, contact:

Rob Buck
The Aerosoft Company
51 N. Cromwell
Fairfield, IA  52556
(515) 472-7586
CompuServe: 72260,3551

