#ifndef _server_h_
#define _server_h_

//  Module: SERVER.H

//  All of the servers defined in this module use their constructors
//  to connect to register channels.  They use there destructors to
//  disconnect from the register channels.

#include    <string.h>
#include    "REGISTER.H"
#include    "CHNNLDEF.H"

class Airport : public WindData, public AirData, public TornadoWarning
{
    char    caName[80];
public:
    Airport (const char *cpName)
                           {strcpy(caName,cpName);
                            oRegister.Connect((WindData *)this);
                            oRegister.Connect((AirData *)this);
                            oRegister.Connect((TornadoWarning *)this);
                           }
    ~Airport (void) {oRegister.Disconnect((WindData *)this);
                     oRegister.Disconnect((AirData *)this);
                     oRegister.Disconnect((TornadoWarning *)this);
                    }
    void ServeWindData (int iSpeed, int iDirection);
    int  ServeAirData (int iTemperature,
                       int iBarometricPressure,
                       int iHumidity);
    void ServeTornadoWarning (void);
};                               

class FireDepartment : public WindData, public AirData, public TornadoWarning
{
public:
    FireDepartment (void)  {oRegister.Connect((WindData *)this);
                            oRegister.Connect((AirData *)this);
                            oRegister.Connect((TornadoWarning *)this);
                           }
    ~FireDepartment (void) {oRegister.Disconnect((WindData *)this);
                     oRegister.Disconnect((AirData *)this);
                     oRegister.Disconnect((TornadoWarning *)this);
                    }
    void ServeWindData (int iSpeed, int iDirection);
    int  ServeAirData (int iTemperature,
                       int iBarometricPressure,
                       int iHumidity);
    void ServeTornadoWarning (void);
};                               

class School : public TornadoWarning
{
public:
    School (void) {oRegister.Connect((TornadoWarning *)this);}
    ~School (void) {oRegister.Disconnect((TornadoWarning *)this);}
    void ServeTornadoWarning (void);
};

#endif
